
REGEX_IPv4='^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+$'
REGEX_IPv6='^([0-9a-fA-F]{0,4}:){1,7}[0-9a-fA-F]{0,4}$'

# This function displays traceroute result of IP/FQDN
traceroute_fun()
{
   echo " ------------------------------------------------"
   echo "|             Trace route host name              |"
   echo " ------------------------------------------------"
   traceroute -n $1
}

PING=$(ping $1 -c 4 2>/dev/null)
PING_RESULT=$?
echo " -------------------------------------------------"
echo "|          Connection reachability test           |"
echo " -------------------------------------------------"
if [ $PING_RESULT -eq 0 ]; then
   echo "${PING}"
   traceroute_fun $1
else
   echo "Connection to host $1 not found"
   traceroute_fun $1
   exit 1
fi

echo " ---------------------------------------------------"
echo "|          Reachability test on port 443            |"
echo " ---------------------------------------------------"
nc -zv -w 2 $1 443 > /dev/null 2>&1
if [ $? -eq 0 ]; then
   echo "Connection to $1 443 port [tcp/https] succeeded!"
else
   echo "Connection to $1 443 port [tcp/https] failed!"
fi

echo " ---------------------------------------------------"
echo "|          Reachability test on port 1234           |"
echo " ---------------------------------------------------"
nc -zv -w 2 $1 1234 > /dev/null 2>&1
if [ $? -eq 0 ]; then
   echo "Connection to $1 1234 port [tcp/*] succeeded!"
else
   echo "Connection to $1 1234 port [tcp/*] failed!"
fi

echo " ---------------------------------------------------"
echo "|          Reachability test on port 1235           |"
echo " ---------------------------------------------------"
nc -zv -w 2 $1 1235 > /dev/null 2>&1
if [ $? -eq 0 ]; then
   echo "Connection to $1 1235 port [tcp/*] succeeded!"
else
   echo "Connection to $1 1235 port [tcp/*] failed!"
fi

echo " --------------------------------------------------"
echo "|          Reachability test on port 8080          |"
echo " --------------------------------------------------"
nc -zv -w 2 $1 8080 > /dev/null 2>&1
if [ $? -eq 0 ]; then
   echo "Connection to $1 8080 port [tcp/http-alt] succeeded!"
else
   echo "Connection to $1 8080 port [tcp/http-alt] failed!"
fi

if ! [[ $1 =~ $REGEX_IPv4 ]] && ! [[ $1 =~ $REGEX_IPv6 ]]; then
    echo " ------------------------------------------------"
    echo "|             Host domain name query             |"
    echo " ------------------------------------------------"
    nslookup $1
fi

