# **********************************************************************
# Copyright 2017 VMware, Inc.  All rights reserved. VMware Confidential.
# **********************************************************************
# $Id$
# $DateTime$
# $Change$
# $Author$
# **********************************************************************
import nsx_logging
import json

import cli.commands.host_shared.ovs_util as ovs_util
from cli.commands.cli_command_provider import CliCommandProvider


lg = nsx_logging.getLogger("cli.commands.host_public_cloud.logical_router")


class HostPublicCloudGetLogicalRouterSummary(CliCommandProvider):
    def __call__(self, cmd_list):
        res = []
        lr_port_count = {}
        lr_list = ovs_util.get_logical_routers_on_vm()  # lport vni vni_status
        if not lr_list:
            return "MSG_PUBLIC_CLOUD_LOGICAL_ROUTER_SUMMARY_FAILED"
        for lr in lr_list:
            lr_uuid = lr[0]
            num_ports = len(ovs_util.get_lif_list(lr_uuid))
            res.append({'uuid': lr_uuid, 'id': lr[1],
                        'num_ports': num_ports})
        return "OK\n\n%s" % json.dumps(res)
